
/********************************************
bi_funct.h
copyright 1991, Michael D. Brennan

This is a source file for mawk, an implementation of
the AWK programming language.

Mawk is distributed without warranty under the terms of
the GNU General Public License, version 2, 1991.
********************************************/


/* $Log: bi_funct.h $
 * Revision 1.7  1997/03/02  11:16:48  koichik
 * Release 3
 *
 * Revision 1.6  1997/02/26  10:24:49  koichik
 * *** empty log message ***
 *
 * Revision 1.2  1997/02/25  16:56:30  koichik
 * add jindex, jlength, jsubstr
 *
 * Revision 1.1  1997/02/19  10:09:16  koichik
 * Adaptation for MBCS
 *
 * Revision 1.2  1994/12/11  22:10:15  mike
 * fflush
 *
 * Revision 1.1.1.1  1993/07/03  18:58:08  mike
 * move source to cvs
 *
 * Revision 5.1  1991/12/05  07:59:03  brennan
 * 1.1 pre-release
 *
*/

#ifndef  BI_FUNCT_H
#define  BI_FUNCT_H  1

#include "symtype.h"

extern BI_REC  bi_funct[] ;

void PROTO(bi_init, (void) ) ;

/* builtin string functions */
CELL *PROTO( bi_print, (CELL *) ) ;
CELL *PROTO( bi_printf, (CELL *) ) ;
CELL *PROTO( bi_length, (CELL *) ) ;
CELL *PROTO( bi_index, (CELL *) ) ;
CELL *PROTO( bi_substr, (CELL *) ) ;
CELL *PROTO( bi_sprintf, (CELL *) ) ;
CELL *PROTO( bi_split, (CELL *) ) ;
CELL *PROTO( bi_match, (CELL *) ) ;
CELL *PROTO( bi_getline, (CELL *) ) ;
CELL *PROTO( bi_sub, (CELL *) ) ;
CELL *PROTO( bi_gsub, (CELL *) ) ;
CELL *PROTO( bi_toupper, (CELL*) ) ;
CELL *PROTO( bi_tolower, (CELL*) ) ;

/* builtin arith functions */
CELL *PROTO( bi_sin, (CELL *) ) ;
CELL *PROTO( bi_cos, (CELL *) ) ;
CELL *PROTO( bi_atan2, (CELL *) ) ;
CELL *PROTO( bi_log, (CELL *) ) ;
CELL *PROTO( bi_exp, (CELL *) ) ;
CELL *PROTO( bi_int, (CELL *) ) ;
CELL *PROTO( bi_sqrt, (CELL *) ) ;
CELL *PROTO( bi_srand, (CELL *) ) ;
CELL *PROTO( bi_rand, (CELL *) ) ;

/* other builtins */
CELL *PROTO( bi_close, (CELL *) ) ;
CELL *PROTO( bi_system, (CELL *) ) ;
CELL *PROTO( bi_fflush, (CELL *) ) ;

#if 1
/* functions for MBCS handling */
CELL *PROTO( bi_lengthl, (CELL *) ) ;
CELL *PROTO( bi_indexl,  (CELL *) ) ;
CELL *PROTO( bi_substrl, (CELL *) ) ;
CELL *PROTO( bi_jlength, (CELL *) ) ;
CELL *PROTO( bi_jindex,  (CELL *) ) ;
CELL *PROTO( bi_jsubstr, (CELL *) ) ;
#ifndef NOEXTEND
CELL *PROTO( bi_systime, (CELL *) ) ;
CELL *PROTO( bi_strftime, (CELL *) ) ;
#endif
#endif
#endif  /* BI_FUNCT_H  */

