/********************************************
miscfunc.c
copyright 1997.  KIMURA Koichi

This file is distributed without warranty under the terms of
the GNU General Public License, version 2, 1991.
********************************************/

#include <string.h>
#include <dos.h>
#include "miscfunc.h"

/* misc funcs */
#ifndef _WIN32
/*
 * mode: specify the conversion mode
 *         GETTRUENAME get the (true) full path name of src
 *         GETSFN convert src lfn -> sfn and store into dest.
 *         GETLFN convert src sfn -> lfn and store into dest.
 */
char *
cnv_fname(char *dest, char *src, int mode)
{
	union REGS reg, nreg;
	struct SREGS sreg;

	if (lfn_state == LFN_DISABLE) {
		return strcpy(dest, src);
	}

	reg.x.ax = LFN_CNVFNAME;
	reg.h.cl = mode;
	reg.h.ch = USE_SUBSTDRIVE;

	reg.x.si = FP_OFF(src);
	sreg.ds  = FP_SEG(src);
	reg.x.di = FP_OFF(dest);
	sreg.es  = FP_SEG(dest);
	intdosx(&reg, &nreg, &sreg);

	if (nreg.x.cflag) { /* something error */
		*dest = '\0'; /* make sure there is end mark */
		/* printf("cnv: %x", nreg.x.ax); */
		/* when file is not existing, nreg.x.ax == 3? */
		return NULL;
	}

	return dest;
}
#endif

#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <time.h>

#define STRFTIME_MISSING 1
#define GAWK 1

#ifdef STRFTIME_MISSING

int do_lint = 0;
void
warning(const char *fmt, ...)
{
   /* do not anything */
}

#include "strftime.c"
#endif

