
/********************************************
version.c
copyright 1991-95.  Michael D. Brennan

This is a source file for mawk, an implementation of
the AWK programming language.

Mawk is distributed without warranty under the terms of
the GNU General Public License, version 2, 1991.
********************************************/

/*$Log: version.c $
 * Revision 1.17  1997/10/26  15:08:17  koichik
 * *** empty log message ***
 *
 * Revision 1.16  1997/10/26  15:07:23  koichik
 * *** empty log message ***
 *
 * Revision 1.15  1997/07/18  17:14:17  koichik
 * Relese 18
 *
 * Revision 1.14  1997/06/15  15:58:19  koichik
 * see change.log
 *
 * Revision 1.13  1997/06/06  15:40:53  koichik
 * release 12
 *
 * Revision 1.12  1997/05/22  16:59:26  koichik
 * Release 11
 *
 * Revision 1.11  1997/05/11  12:04:46  koichik
 * inc release no.
 *
 * Revision 1.10  1997/05/07  11:21:28  koichik
 * *** empty log message ***
 *
 * Revision 1.9  1997/04/27  16:25:07  koichik
 * increment release no.
 *
 * Revision 1.8  1997/03/08  13:12:11  koichik
 * *** empty log message ***
 *
 * Revision 1.7  1997/03/02  11:16:48  koichik
 * Release 3
 *
 * Revision 1.6  1997/02/26  10:26:00  koichik
 * *** empty log message ***
 *
 * Revision 1.2  1997/02/25  16:53:58  koichik
 * Release 2
 *
 * Revision 1.1  1997/02/19  09:58:08  koichik
 * Initial revision
 *
 *Revision 1.10  1996/07/28 21:47:07  mike
 *gnuish patch
 *
 * Revision 1.9  1996/02/01  04:44:15  mike
 * roll a beta version
 *
 * Revision 1.8  1995/08/20  17:40:45  mike
 * changed _stackavail to stackavail for MSC
 *
 * Revision 1.7  1995/06/10  17:04:10  mike
 * "largest field" replaced by "max NF"
 *
*/

#include "mawk.h"
#include "patchlev.h"

static char mawkid[] = MAWK_ID ;

#if 0
#define	 VERSION_STRING	 \
  "mawk 1.3%s%s %s, Copyright (C) Michael D. Brennan\n\n"
#else
#define	 VERSION_STRING	 \
  "mawk 1.3%s%s %s, Copyright (C) Michael D. Brennan\n"
#endif

/* If use different command line syntax for MSDOS
   mark that in VERSION	 */

#ifndef DOS_STRING
#if  MSDOS && ! HAVE_REARGV
#ifndef _WIN32
#define DOS_STRING  "MsDOS"
#else
#define DOS_STRING   "Win32"
#endif /* _WIN32*/
#endif
#endif

#ifndef DOS_STRING
#define DOS_STRING	""
#endif

static char fmt[] = "%-14s%10lu\n" ;

#define RELNO 28

/* print VERSION and exit */
void
print_version()
{

   printf(VERSION_STRING, PATCH_STRING, DOS_STRING, DATE_STRING) ;
   printf("  Adaptation for MBCS (%s R%d) by KIMURA Koichi\n\n", 
            "P. yedoensis", RELNO);
   fflush(stdout) ;

   print_compiler_id() ;
   fprintf(stderr, "compiled limits:\n") ;
   fprintf(stderr, fmt, "max NF", (long) MAX_FIELD) ;
   fprintf(stderr, fmt, "sprintf buffer", (long) SPRINTF_SZ) ;
   print_aux_limits() ;
   exit(0) ;
}


/*
  Extra info for MSDOS.	 This code contributed by
  Ben Myers
*/

#ifdef __TURBOC__
#include <alloc.h>		/* coreleft() */
#define	 BORL
#endif

#ifdef __BORLANDC__
#include <alloc.h>		/* coreleft() */
#define	 BORL
#endif

#ifdef	BORL
extern unsigned _stklen = 16 * 1024U ;
 /*  4K of stack is enough for a user function call
       nesting depth of 75 so this is enough for 300 */
#endif

#ifdef _MSC_VER
#include <malloc.h>
#endif

#ifdef __ZTC__
#include <dos.h>		/* _chkstack */
#endif


int
print_compiler_id()
{

#ifdef	__TURBOC__
   fprintf(stderr, "MsDOS Turbo C++ %d.%d\n",
	   __TURBOC__ >> 8, __TURBOC__ & 0xff) ;
#endif

#ifdef __BORLANDC__
   fprintf(stderr, "MS-DOS Borland C++ __BORLANDC__ %x\n",
	   __BORLANDC__) ;
#endif

#ifdef _MSC_VER
   fprintf(stderr, "Microsoft C/C++ _MSC_VER %u\n", _MSC_VER) ;
#endif

#ifdef __ZTC__
   fprintf(stderr, "MS-DOS Zortech C++ __ZTC__ %x\n", __ZTC__) ;
#endif

   return 0 ;			 /*shut up */
}


int
print_aux_limits()
{
#ifdef BORL
   extern unsigned _stklen ;
   fprintf(stderr, fmt, "stack size", (unsigned long) _stklen) ;
   fprintf(stderr, fmt, "heap size", (unsigned long) coreleft()) ;
#endif

#if defined(_MSC_VER) && !defined(_WIN32)
   fprintf(stderr, fmt, "stack size", (unsigned long) stackavail()) ;
#endif

#ifdef __ZTC__
/* large memory model only with ztc */
   fprintf(stderr, fmt, "stack size??", (unsigned long) _chkstack()) ;
   fprintf(stderr, fmt, "heap size", farcoreleft()) ;
#endif

   return 0 ;
}
