/* This program code come from serrow's xargs.c.
 * You can use this code as on the public domain
 * except when you are going to use for shareware/package software.
 *   KIMURA Koichi 1997/03/01
 */

/* Id: xargs.c 2.3 1993/09/04 17:09:31 serow Exp serow
 *
 * wild card expand routine for BORLAND C, MS C, LSI C..
 *
 * $Log: xargs.c $
 * Revision 1.10  1997/04/27  15:01:25  koichik
 * fix funny process
 *
 * Revision 1.9  1997/04/05  09:53:11  koichik
 * bug fix (position of intdos?())
 *
 * Revision 1.8  1997/03/08  13:12:11  koichik
 * *** empty log message ***
 *
 * Revision 1.7  1997/03/02  11:16:48  koichik
 * Release 3
 *
 * Revision 2.3  1993/09/04  17:09:31  serow
 * _heapmin (MS-C)
 *
 * Revision 2.2  1993/05/22  04:33:02  serow
 * Oargv[0]
 *
 * Revision 2.1  1993/01/20  10:43:04  serow
 * v2
 *
 */

#include <stdio.h>
#include <dos.h>
#include <string.h>
#include <io.h>
#include <stdlib.h>
#include "xargs.h"

#ifdef TEST
#define static
#endif

static unsigned long xargs_rule = XARGS_CSH_LIKE_RULE;

#if 0
#define OnlySubDir  (0x100)
#define AllFindAttr (0x17)
#else
#define OnlySubDir  (1<<31)
#define AllFindAttr (0xB7)
#endif
#define INVERTCHAR  '^'
#define LBRACE      '['
#define RBRACE      ']'
#define LCURLY      '{'
#define RCURLY      '}'
#define Isend(c)    ((c) == '\0' || ((xargs_rule & XARGS_DOTBREAK) && (c) == '.'))
#define Iswild(c)   ((c) == '*' || (c) == '?' || (c) == LBRACE || (c) == LCURLY)
#define Isupper(c)  ('A' <= (c) && (c) <= 'Z')
#define Isspace(c)  ((c) == ' ' || (c) == '\t' || (c) == '\n' || (c) == '\r')
/* ascii only */
#define Tolower(c)  ((c) | 0x20)
/* Shift-JIS only */
#define isk1(c)	((0x81 <= (unsigned char)(c) && (unsigned char)(c) <= 0x9F)\
              || (0xE0 <= (unsigned char)(c) && (unsigned char)(c) <= 0xFC))
#if 0
#define REALLOC_UNIT	128
#else
#define REALLOC_UNIT	512
#endif

#ifdef __TURBOC__
#if (sizeof(char *) == 4)
#define LARGE_DATA	1
#endif
#else	/* may be MS-C */
#if defined(M_I86LM) || defined(M_I86CM) || defined(M_I86HM)
#define LARGE_DATA	1
#endif
#endif

#if defined(LSI_C)
/* union REGS dose not have '.cflag' but '.flags' */
#else
#define HAVE_CFLAG	1
#endif

#ifdef _MSC_VER
/* MS-C */
#define NEAR	_near
#else
#define NEAR
#endif

#undef FP_OFF
#undef FP_SEG
#undef MK_FP
#define FP_OFF(fp)	((unsigned int)((unsigned long)((void far *)(fp)) & 0xFFFFL))
#define FP_SEG(fp)	((unsigned int)((unsigned long)((void far *)(fp)) >> 16))
#define MK_FP(sg, of)	((void far *)(((unsigned long)(sg) << 16)|(unsigned)(of)))

typedef struct {
    char d_buf[21];
    char d_attribute;
    unsigned short d_time;
    unsigned short d_date;
    long d_size;
    char d_name[13];
} DTA_BUF;

static DTA_BUF dtabuf;
static union REGS reg, nreg;
#ifdef LARGE_DATA
static struct SREGS sreg;
#endif

static char ERNOMEM[] = "not enough memory.\r\n";

int lfn_state = LFN_DISABLE;
static int hFind = INVALID_HFINDFILE;
static WIN32_FIND_DATA dta;

/***************************************************************/

int
check_lfn()
{
	char drvtype[32];
	char drvname[] = "c:\\";

	reg.x.ax = LFN_GETDRVINF;

#ifdef LARGE_DATA
	reg.x.di = FP_OFF(drvtype);
	sreg.es  = FP_SEG(drvtype);
	reg.x.dx = FP_OFF(drvname);
	sreg.ds  = FP_SEG(drvname);
	intdosx(&reg, &nreg, &sreg);
#else
	reg.x.di = (unsigned int)drvtype;
	reg.x.dx = (unsigned int)drvname;
	intdos(&reg, &nreg);
#endif

	if (nreg.x.ax == ERROR_NOLFN)
		return LFN_DISABLE;
	else
		return LFN_ENABLE;
}


int NEAR
FindFirstFile(char *dir, WIN32_FIND_DATA *dta)
{
	reg.x.ax = LFN_FINDFIRST;
	reg.h.cl = dta->dwFileAttributes & 0xff;
	reg.h.ch = 0; /* required attribute is nothing */
	reg.x.si = DATE_64BITFOMAT;

#ifdef LARGE_DATA
	reg.x.di = FP_OFF(dta);
	sreg.es  = FP_SEG(dta);
	reg.x.dx = FP_OFF(dir);
	sreg.ds  = FP_SEG(dir);
	intdosx(&reg, &nreg, &sreg);
#else
	reg.x.si = (unsigned int)dta;
	reg.x.dx = (unsigned int)dir;
	intdos(&reg, &nreg);
#endif

	if (nreg.x.cflag)
		return 0;
	else
		return nreg.x.ax;
}

int NEAR
FindNextFile(int handle, WIN32_FIND_DATA *dta)
{
	reg.x.ax = LFN_FINDNEXT;
	reg.x.bx = handle;
	reg.x.si = DATE_64BITFOMAT;

#ifdef LARGE_DATA
	reg.x.di = FP_OFF(dta);
	sreg.es  = FP_SEG(dta);
	intdosx(&reg, &nreg, &sreg);
#else
	reg.x.dx = (unsigned int)dta;
	intdos(&reg, &nreg);
#endif

	return nreg.x.cflag ? 0 : 1;
}

int NEAR
FindClose(int handle)
{
	reg.x.ax = LFN_FINDCLOSE;
	reg.x.bx = handle;

#ifdef LARGE_DATA
	intdosx(&reg, &nreg, &sreg);
#else
	intdos(&reg, &nreg);
#endif

	return 0;
}

static char* NEAR
find_file_lfn(char* dir , DWORD Attr)
{
	char *ret = NULL;

	if (hFind == 0 || hFind == -1) {	/* get first entry */
		dta.dwFileAttributes = (DWORD)(Attr & 0xffff);
		if ((hFind = FindFirstFile(dir, &dta)) != -1)
			ret = dta.cFileName;
	} else {			/* get next entry */
retry:
		if (FindNextFile(hFind, &dta))
			ret = dta.cFileName;
	}

	if (ret && (!strcmp(ret, "..") || !strcmp(ret, ".")))
		goto retry;

	if ((Attr & OnlySubDir) && (dta.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) == 0)
		goto retry;

	if (ret[0] == '.' && (xargs_rule & XARGS_HIDDENDOT) 
             && (dta.dwFileAttributes & FILE_ATTRIBUTE_HIDDEN) == 0)
		goto retry;

	return ret;
}

static void NEAR
error(char * s)
{
	write(2, "xargs: ", 7);
	write(2, s, strlen(s));
	exit(1);
}

static void NEAR
set_dta(void)
{
    reg.h.ah = 0x1A;
#ifdef LARGE_DATA
    reg.x.dx = FP_OFF(&dtabuf);
    sreg.ds = FP_SEG(&dtabuf);
    intdosx(&reg, &nreg, &sreg);
#else
    reg.x.dx = (int) &dtabuf;
    intdos(&reg, &nreg);
#endif
}

static char *NEAR
find_file(char *dir, DWORD Attr)
{
    if (lfn_state)
    	return find_file_lfn(dir , Attr);

    if (dir != (char *) 0) {	/* get first entry */
	set_dta();
	reg.h.ah = 0x4E;
	reg.h.cl = (char) Attr;
#ifdef LARGE_DATA
	reg.x.dx = FP_OFF(dir);
	sreg.ds = FP_SEG(dir);
#else
	reg.x.dx = (unsigned) dir;
#endif
    } else {			/* get next entry */
      retry:;
	set_dta();
	reg.h.ah = 0x4F;
#ifdef LARGE_DATA
	reg.x.dx = FP_OFF(&dtabuf);
	sreg.ds = FP_SEG(&dtabuf);
#else
	reg.x.dx = (unsigned) &dtabuf;
#endif
    }
#ifdef LARGE_DATA
    intdosx(&reg, &nreg, &sreg);
#else
    intdos(&reg, &nreg);
#endif

#ifdef HAVE_CFLAG
    if (nreg.x.cflag)
#else
    if (nreg.x.flags & 1)
#endif
	return (char *) 0;

    if (dtabuf.d_name[0] == 5)
	dtabuf.d_name[0] = (char) 0xE5;

    if (Attr & OnlySubDir) {
        if ((dtabuf.d_attribute & 0x10) == 0)
	    goto retry;
	if (dtabuf.d_name[0] == '.')
	    goto retry;
    }
    if (dtabuf.d_name[0] == '.' && (xargs_rule & XARGS_HIDDENDOT) && (Attr & 2) == 0)
	goto retry;

    return dtabuf.d_name;
}

static char * NEAR
jstrtolwr(char *p)
{
    char *op = p;

    while (*p) {
	if (isk1(*p) && p[1])
	    p++;
	else if (Isupper(*p))
	    *p = (char) Tolower(*p);
	p++;
    }
    return op;
}

static char * NEAR
jrindex(char *p, int c)
{
    char *oldp;

    c &= 0xFF;
    for (oldp = 0; *p; p++) {
	if (isk1(*p) && p[1]) {
	    p++;
	} else if (((*p) & 0xFF) == c) {
	    oldp = p;
	}
    }
    return oldp;
}

static int
ustrcmp(void const *s1, void const *s2)
{
    unsigned char *p1 = *(unsigned char **)s1;
    unsigned char *p2 = *(unsigned char **)s2;

    while ((*p1 != '\0') && (*p1 == *p2)) {
	p1++;
	p2++;
    }
    return *p1 - *p2;
}

static char * NEAR
xmalloc(size_t n)
{
    char *bp;

    if ((bp = calloc(1, n)) == (char *) 0)
	error(ERNOMEM);
    return bp;
}

static char * NEAR
xrealloc(void *blk, size_t n)
{
    char *bp;

    if ((bp = realloc(blk, n)) == (char *) 0)
	error(ERNOMEM);
#ifdef _MSC_VER
    _heapmin();
#endif
    return bp;
}
static void NEAR
xfree(void *p)
{
    if (p)
	free(p);
#ifdef _MSC_VER
    _heapmin();
#endif
}

static int NEAR
has_glob_char(char *pat)
{
    int c;

    while ((c = *pat++) != '\0') {
	if (Iswild(c))
	    return 1;
	if (isk1(c) && *pat)
	    pat++;
    }
    return 0;
}

#define Scan(c, p) {\
        c = (unsigned char)(*p++);\
        if (isk1(c) && *p) \
            c = (c << 8) + (unsigned char)(*p++);\
        else if (Isupper(c))\
            c = Tolower(c);\
        }
#define ScanRaw(c, p) {\
	c = (unsigned char)(*p++);\
	if (isk1(c) && *p)\
	    c = (c << 8) + (unsigned char)(*p++);\
	}

static int NEAR
glob_match(char *text, char *pattern)
{
    int include, exclude;
    unsigned int ks, ke, kp, kt;
    char *start, *stop;

    while (*pattern) {
	switch (*pattern) {
	case LCURLY:
	    if (Isend(*text))
		return 0;
	    stop = start = text;
	    pattern++;
	    do {
		text = start;
		include = 1;
		do {
		    if (Isend(*pattern))
			return 0; /*ERMISSCURLY*/
		    Scan(kt, text);
		    Scan(kp, pattern);
		    if (kt != kp)
			include = 0;
		} while (*pattern != ',' && *pattern != RCURLY);

		if (include && text - start > stop - start)
		    stop = text;
		if (*pattern == ',')
		    pattern++;
	    } while (*pattern != RCURLY);
	    if (stop == start)
		return 0;
	    pattern++;
	    text = stop;
	    break;

	case '?':
	    if (Isend(*text))
		return 0;
	    ScanRaw(kt, text);
	    pattern++;
	    break;

	case '*':
	    while ((include = glob_match(text, pattern + 1)) == 0 && !Isend(*text)) {
		ScanRaw(kt, text);
	    }
	    return include;

	case LBRACE:
	    if (Isend(*text))
		return 0;
	    include = exclude = 0;
	    pattern++;
	    if (*pattern == INVERTCHAR) {
		exclude = 1;
		pattern++;
	    }
	    Scan(kt, text);
	    do {
		if (Isend(*pattern))
		    return 0; /*ERMISSBRACKET*/
		Scan(ks, pattern);
		ke = ks;
		if (*pattern == '-' && *(pattern + 1) != RBRACE) {
		    pattern++;
		    if (Isend(*pattern))
			return 0; /*ERMISSBRACKET*/
		    Scan(ke, pattern);
		}
		if (ks <= kt && kt <= ke) {
		    include = 1;
		    /* no break to checking missing brace */
		    /*break;*/
		}
	    } while (*pattern != RBRACE);

	    if (include == exclude)
		return 0;
	    pattern++;
	    break;

	case '.':
	    if (xargs_rule & XARGS_DOTBREAK) {
		if (!Isend(*text))
		    return 0;
		if (*text == '.')
		    text++;
		pattern++;
		break;
	    }
	default:
	    Scan(kt, text);
	    Scan(kp, pattern);
	    if (kt != kp)
		return 0;
	}
    }
    return *text == '\0' ? 1 : 0;
}

static char * NEAR
jrpathdlm(char *s)
{
    char *ap, *ap1, *ap2;

    ap1 = jrindex(s, '\\');
    ap2 = jrindex(s, '/');
    if ((ap = (ap1 < ap2) ? ap2 : ap1) == (char *) 0)
	ap = jrindex(s, ':');
    return ap;
}

char **
glob_filename(char *pattern)
{
    char *ap, *ap1, *ap2;
    char **res;
    char *pat;
    char **paths;
    char *dirp;
    char *wld;
    char *pp;
    int ra, ri, i, plen;
    int np;
    DWORD attr = ((int) (xargs_rule & 0xFF));

    ap = jrpathdlm(pattern);
    if (ap && ap[0] != ':' && ap[1] == '\0') {
	attr = AllFindAttr | OnlySubDir;
	pp = (char *) xmalloc(strlen(pattern) + 1);
	strcpy(pp, pattern);
	pp[(int) (ap - pattern)] = '\0';
	ap = jrpathdlm(pp);
	if (ap)
	    ap = pattern + (int) (ap - pp);
	xfree(pp);
    }
    if (ap) {
	pat = xmalloc(strlen(ap + 1) + 1);
	strcpy(pat, ap + 1);
	ap2 = dirp = (char *) xmalloc((int) (ap - pattern) + 2);
	for (ap1 = pattern; ap1 <= ap; ap1++)
	    *ap2++ = *ap1;
	*ap2 = '\0';
	if (ap[0] != ':' && has_glob_char(dirp)) {
	    paths = glob_filename(dirp);
	    xfree(dirp);
	} else {
	    paths = (char **) xmalloc(sizeof(paths[0]) * 2);
	    paths[0] = dirp;
	    paths[1] = (char *) 0;
	}
    } else {
	pat = xmalloc(strlen(pattern) + 1);
	strcpy(pat, pattern);
	paths = (char **) xmalloc(sizeof(paths[0]) * 2);
	paths[0] = (char *) xmalloc(2);
	paths[1] = (char *) 0;
	strcpy(paths[0], "");
    }
    ap = jrpathdlm(pat);
    if (ap && ap[0] != ':' && ap[1] == '\0') {
	ap[0] = '\0';
    }
    res = (char **) xmalloc(sizeof(char *) * (ra = 128));
    ri = 0;
    res[ri] = 0;
    for (i = 0; paths[i]; i++) {
	plen = strlen(paths[i]);
	wld = xmalloc(plen + 5);
	strcpy(wld, paths[i]);
	ap = jrpathdlm(wld);
	if (plen == 0 || (ap && ap[1] == '\0')) {
	    np = 0;
	} else {
	    strcat(wld, "/");
	    np = 1;
	}
	strcat(wld, "*.*");
	if ((ap = find_file(wld, attr)) != (char *) 0) {
	    do {
		if (glob_match(ap, pat)) {
		    if (xargs_rule & XARGS_CVLOWER)
			jstrtolwr(ap);
		    if (strlen(ap)==0)
		    	continue;

		    res[ri] = xmalloc(plen + strlen(ap) + 2);
		    strncat(strcat(strcpy(res[ri], paths[i]), np ? "/" : ""), ap, LFN_MAX);
		    res[++ri] = (char *) 0;
		    if (ri >= ra - 2) {
			    res = (char **) xrealloc(res, sizeof(char *) * (ra += 128));
		    }
		}
	    } while ((ap = find_file((char *) 0, attr)) != (char *) 0);

	    if (lfn_state) {
	    	FindClose(hFind);
	    	hFind = INVALID_HFINDFILE;
	    }
	}
	xfree(wld);
    }
    if (ri) {
        if (xargs_rule & XARGS_DOSORT)
            qsort(&res[0], ri, sizeof(res[0]), ustrcmp);
    } else {
	strcpy(res[ri] = xmalloc(strlen(pattern) + 1), pattern);
	res[++ri] = (char *) 0;
    }
    xfree(pat);
    for (i = 0; paths[i]; i++)
	xfree(paths[i]);
    xfree(paths);
    return res;
}

/******/
struct inputredir {
    int type;
#define IP_FILE 1
#define IP_MEM  2
    struct inputredir *next;
    union {
	FILE *fp;
	char *cp;
    } i;
};
static struct inputredir *iroot = 0;

static void NEAR
add_input(void *p, int type)
{
    struct inputredir *ip;

    ip = (struct inputredir *) xmalloc(sizeof(struct inputredir));
    ip->type = type;
    ip->i.cp = p;
    if (iroot) {
	ip->next = iroot;
	iroot = ip;
    } else {
	iroot = ip;
	iroot->next = 0;
    }
}

static int pushbackc = -1;

static int NEAR
nextc(void)
{
    int c;
    struct inputredir *lip;

    if (pushbackc != -1) {
	c = pushbackc;
	pushbackc = -1;
	return c;
    }
    if (iroot == 0)
	return EOF;
    switch (iroot->type) {
    case IP_FILE:
	if ((c = fgetc(iroot->i.fp)) == EOF) {
	    fclose(iroot->i.fp);
	    lip = iroot;
	    iroot = iroot->next;
	    xfree(lip);
	    c = nextc();
	}
	break;
    case IP_MEM:
	if ((c = *(iroot->i.cp++)) == '\0') {
	    lip = iroot;
	    iroot = iroot->next;
	    xfree(lip);
	    c = nextc();
	}
	break;
    default:
        c = EOF;
	break;
    }
    return c;
}
static void NEAR
pushback(int c)
{
    pushbackc = c;
}

/******/

static void NEAR
setav(char *NCptr, int *_ARGC, char ***_ARGV)
{
    int   c, i, jf, at;
    int   quote, withwild;
    char *ap;
    char *buf;
    size_t absiz;
    size_t bfsiz;
#define argbuf (*_ARGV)
#define argcnt (*_ARGC)
    char **res;
    FILE  *fp;

    buf = (char *) xmalloc((bfsiz = REALLOC_UNIT * 2) * sizeof(char));
    argbuf = (char **) xmalloc((absiz = REALLOC_UNIT) * sizeof(char *));
    argcnt = 0;

    add_input(NCptr, IP_MEM);

    while ((c = nextc()) != EOF) {
	withwild = quote = 0;
	while (Isspace(c))
	    c = nextc();
	if (c == EOF)
	    break;
	at = (c == '@') ? 1 : 0;
	ap = buf;
	jf = 0;
	do {
	    if (ap == &buf[bfsiz - 1]) {
		buf = (char *) xrealloc(buf, (bfsiz + REALLOC_UNIT) * sizeof(buf[0]));
		ap = &buf[bfsiz - 1];
		bfsiz += REALLOC_UNIT;
	    }
	    if (jf || isk1(c)) {
		*ap++ = (char) c;
		jf = !jf;
		continue;
	    }
	    if (!quote && Iswild(c))
		withwild = 1;
	    if (c == quote) {	/* end of quoted string */
		quote = 0;
	    } else if (!quote && (c == '\'' || c == '"')) {
		quote = c;
	    } else {
		if (c == '\\') {
		    c = nextc();
		    if (c != '"' && c != '\'') {
			pushback(c);
			c = '\\';
		    }
		}
		*ap++ = (char) c;
	    }
	} while ((c = nextc()) != EOF && (quote || !Isspace(c)));
	*ap = 0;
	if ((xargs_rule & XARGS_ATRESP) && at) {
	    if ((fp = fopen(buf + 1, "r")) != 0) {
	        add_input(fp, IP_FILE);
	        continue;
	    } else {
		/* ignore */
	    }
	}
	if (withwild) {
	    res = glob_filename(buf);
	} else {
	    res = (char **) xmalloc(sizeof(char *) * 2);
	    strcpy(res[0] = (char *) xmalloc(strlen(buf) + 1), buf);
	    res[1] = (char *) 0;
	}
	for (i = 0; res[i]; i++) {
	    argbuf[argcnt++] = res[i];
	    if ((size_t) argcnt >= absiz) {
		argbuf = (char **) xrealloc(argbuf, (absiz += REALLOC_UNIT) * sizeof(argbuf[0]));
	    }
	}
	xfree(res);
    }
    argbuf[argcnt] = (char *) 0;
    argbuf = (char **) xrealloc(argbuf, (argcnt + 1) * sizeof(argbuf[0]));
    xfree(buf);
}

unsigned long
xargs_set_rule(unsigned long rule)
{
    unsigned long lastrule;

    lastrule = xargs_rule; 
    xargs_rule = rule; 
    return lastrule;
}

unsigned long
xargs_modify_rule(unsigned long mask, unsigned long rule)
{
    unsigned long lastrule;

    lastrule = xargs_rule; 
    xargs_rule = (xargs_rule & ~mask) | rule;
    return lastrule;
}

void
xargs(int *argc, char ***argv)
{
    char far *pp;
    char *s;
    int i, j;
    int jf = 0;
    int li = 0;
    int sa = 0;

    if (!(xargs_rule & XARGS_USECMDL)
      || (s = getenv("CMDLINE")) == 0
      || getenv("NOCMDLINE") != 0) {
	sa = 1;
	if (_osmajor >= 3) {
	    pp = MK_FP(*(unsigned int far *)MK_FP(_psp, 0x2C), 0); /* environ */
	    while (pp[0] != 0 || pp[1] != 0)
		pp++;
	    pp += 4;
	} else {
	    pp = "xargs";
	}
	s = xmalloc(1024);
	for (i = 0; (s[i] = *pp++) != '\0'; i++) {
	    if (jf) {
		jf = 0;
		continue;
	    }
	    if (isk1(s[i]) && !jf) {
		jf = 1;
		continue;
	    }
	    if ((xargs_rule & XARGS_0CVLOWER) && Isupper(s[i]))
		s[i] = (char) Tolower(s[i]);
	    if (s[i] == '.')
		li = i;
	    if (s[i] == '/' || s[i] == '\\')
		li = 0;
	    if ((xargs_rule & XARGS_0CVSLASH) && s[i] == '\\')
		s[i] = '/';
	}
	if ((xargs_rule & XARGS_0REMOVEXT) && li && li != i - 1) {
	    i = li;
	    s[i] = 0;
	}
	pp = MK_FP(_psp, 128);
	j = *pp++;
	while ((*pp == ' ' || *pp == '\t') && j) {
	    pp++;
	    j--;
	}
	if (j)
	    s[i++] = ' ';
	while (j--) {
	    s[i++] = *pp++;
	}
	s[i] = 0;
    }
    setav(s, argc, argv);
    if (sa)
	xfree(s);
}


#ifdef TEST
#include <stdlib.h>

static char QUOTE[]= "\033[33m\"\033[m";

void
main(int argc, char **argv)
{
    int a = 0;
    char sfn[67];

    lfn_state =  check_lfn();

    /*xargs_modify_rule(XARGS_DOTBREAK, XARGS_DOTBREAK);*/
    xargs(&argc, &argv);

    printf("[argv]-------------------------- %d argument(s)\n", argc);
    while (argc--) {
	printf("[%4d]%s%s : %s%s\n", a++, QUOTE, 
	    cnv_fname(sfn, *argv, GETSFN), *argv, QUOTE);
	    *argv++;
    }
    printf("-------------------------------- Thats all\n");
}

#endif
