/* $Id: xargs.h 1.7 1997/03/02 11:16:48 koichik Exp koichik $
 *
 * header for xargs.c
 * This code is in the public domain.
 *
 * $Log: xargs.h $
 * Revision 1.7  1997/03/02  11:16:48  koichik
 * Release 3
 *
 * Revision 2.1  1993/01/20  10:43:04  serow
 * v2
 *
 */

#ifndef _INC_XARGS
#ifdef __cplusplus
extern "C" {
#endif

/* The following bits are used in the xargs_rule variable
   to select globbing rule */

#define XARGS_F_RO	(1L       ) /*  attribute for find file. */
#define XARGS_F_HID	(1L <<  1L) /*  */
#define XARGS_F_SYS	(1L <<  2L) /*  */
#define XARGS_F_VOL	(1L <<  3L) /*  */
#define XARGS_F_DIR	(1L <<  4L) /*  */

#define XARGS_DOTBREAK	(1L << 22L) /* ?, * doesnot math with '.'              */
#define XARGS_HIDDENDOT	(1L << 23L) /* treat '.' & '..' as hidden file         */
#define XARGS_DOSORT	(1L << 24L) /* wild card args will be sorted by name   */
#define XARGS_CVLOWER	(1L << 25L) /* convert filenames to lower case         */
#define XARGS_ATRESP	(1L << 26L) /* @responsefile                           */
#define XARGS_USECMDL	(1L << 27L) /* get arg from "CMDLINE" environ if there */
#define XARGS_0CVLOWER	(1L << 28L) /* convert argv[0] to lower case           */
#define XARGS_0CVSLASH	(1L << 29L) /* convert '\\' to '/' in argv[0]          */
#define XARGS_0REMOVEXT	(1L << 30L) /* remove extention from argv[0]           */

/* copy from windows.h (win95sdk) */

#ifndef DWORD
typedef unsigned long   DWORD;
#endif

#ifndef _FILETIME_
#define _FILETIME_
typedef struct _FILETIME {
    DWORD dwLowDateTime;
    DWORD dwHighDateTime;
} FILETIME;
#endif

#ifndef _WIN32_FIND_DATA
#define LFN_MAX 260
#pragma pack(1)
typedef struct _WIN32_FIND_DATA {
    DWORD dwFileAttributes;
    FILETIME ftCreationTime;
    FILETIME ftLastAccessTime;
    FILETIME ftLastWriteTime;
    DWORD nFileSizeHigh;
    DWORD nFileSizeLow;
    DWORD dwReserved0;
    DWORD dwReserved1;
    char   cFileName[ LFN_MAX ];
    char   cAlternateFileName[ 14 ];
} WIN32_FIND_DATA;
#pragma pack()

#define FILE_ATTRIBUTE_READONLY         0x00000001L
#define FILE_ATTRIBUTE_HIDDEN           0x00000002L
#define FILE_ATTRIBUTE_SYSTEM           0x00000004L
#define FILE_ATTRIBUTE_DIRECTORY        0x00000010L
#define FILE_ATTRIBUTE_ARCHIVE          0x00000020L
#define FILE_ATTRIBUTE_NORMAL           0x00000080L
#define FILE_ATTRIBUTE_TEMPORARY        0x00000100L
#define FILE_ATTRIBUTE_ATOMIC_WRITE     0x00000200L
#define FILE_ATTRIBUTE_XACTION_WRITE    0x00000400L

#define INVALID_HFINDFILE       (-1)

#endif
/************************************************/

/* typical rules */

#define XARGS_CSH_LIKE_RULE (\
	 XARGS_F_RO|XARGS_F_DIR|XARGS_F_SYS \
	|XARGS_HIDDENDOT \
	|XARGS_DOSORT \
	|XARGS_CVLOWER \
	|XARGS_ATRESP \
	|XARGS_0CVLOWER \
	|XARGS_0CVSLASH \
	|XARGS_0REMOVEXT \
    )

#define XARGS_MESSY_RULE (\
	 XARGS_F_RO|XARGS_F_SYS \
	|XARGS_DOTBREAK \
	|XARGS_HIDDENDOT \
    )

#define DATE_64BITFOMAT 0
#define DATE_MSDOSFOMAT 1
#define LFN_ENABLE      1
#define LFN_DISABLE     0
#define LFN_FINDFIRST   0x714e
#define LFN_FINDNEXT    0x714f
#define LFN_GETDRVINF   0x71a0
#define LFN_FINDCLOSE   0x71a1
#define LFN_CNVFNAME    0x7160
#define GETTRUENAME     0
#define GETSFN          1
#define GETLNF          2
#define USE_SUBSTDRIVE  0x80
#define NOUSE_SUBSTDRIVE 0
#define ERROR_NOLFN     0x7100

/* prototypes */

int           check_lfn();
char *        cnv_fname(char* dest, char* src, int mode);
char **       glob_filename(char *pattern);
unsigned long xargs_set_rule(unsigned long rule);
unsigned long xargs_modify_rule(unsigned long mask, unsigned long rule);
void          xargs(int *argc, char ***argv);

/* variables */
extern int lfn_state;

#ifdef __cplusplus
}
#endif
#define _INC_XARGS	1
#endif /* _INC_XARGS */
