/* Id: xargs.h 2.1 1993/01/20 10:43:04 serow Exp serow 
 *
 * header for xargs.c
 * This code is in the public domain.
 *
 * $Log: xargs32.h $
 * Revision 1.1  1997/04/27  15:04:01  koichik
 * Initial revision
 *
 * Revision 2.1  1993/01/20  10:43:04  serow
 * v2
 *
 */

#ifndef _INC_XARGS
#ifdef __cplusplus
extern "C" {
#endif

/* The following bits are used in the xargs_rule variable
   to select globbing rule */

#define XARGS_F_RO	(1L       ) /*  attribute for find file. */
#define XARGS_F_HID	(1L <<  1L) /*  */
#define XARGS_F_SYS	(1L <<  2L) /*  */
#define XARGS_F_VOL	(1L <<  3L) /*  */
#define XARGS_F_DIR	(1L <<  4L) /*  */

#define XARGS_DOTBREAK	(1L << 22L) /* ?, * doesnot math with '.'              */
#define XARGS_HIDDENDOT	(1L << 23L) /* treat '.' & '..' as hidden file         */
#define XARGS_DOSORT	(1L << 24L) /* wild card args will be sorted by name   */
#define XARGS_CVLOWER	(1L << 25L) /* convert filenames to lower case         */
#define XARGS_ATRESP	(1L << 26L) /* @responsefile                           */
#define XARGS_USECMDL	(1L << 27L) /* get arg from "CMDLINE" environ if there */
#define XARGS_0CVLOWER	(1L << 28L) /* convert argv[0] to lower case           */
#define XARGS_0CVSLASH	(1L << 29L) /* convert '\\' to '/' in argv[0]          */
#define XARGS_0REMOVEXT	(1L << 30L) /* remove extention from argv[0]           */

/* typical rules */

#define XARGS_CSH_LIKE_RULE (\
	 XARGS_F_RO|XARGS_F_DIR|XARGS_F_SYS \
	|XARGS_HIDDENDOT \
	|XARGS_DOSORT \
	|XARGS_CVLOWER \
	|XARGS_ATRESP \
	|XARGS_0CVLOWER \
	|XARGS_0CVSLASH \
	|XARGS_0REMOVEXT \
    )

#define XARGS_MESSY_RULE (\
	 XARGS_F_RO|XARGS_F_SYS \
	|XARGS_DOTBREAK \
	|XARGS_HIDDENDOT \
    )

/* prototypes */

char **       glob_filename(char *pattern);
unsigned long xargs_set_rule(unsigned long rule);
unsigned long xargs_modify_rule(unsigned long mask, unsigned long rule);
void          xargs(int *argc, char ***argv);
#ifdef __cplusplus
}
#endif
#define _INC_XARGS	1
#endif /* _INC_XARGS */
